[![pipeline status](https://gitlab.com/archsoft/wdio-coverage-reporter/badges/master/pipeline.svg)](https://gitlab.com/archsoft/wdio-coverage-reporter/-/commits/master)
[![coverage report](https://gitlab.com/archsoft/wdio-coverage-reporter/badges/master/coverage.svg)](https://gitlab.com/archsoft/wdio-coverage-reporter/-/commits/master)

WDIO COVERAGE Reporter
===================

A WebdriverIO plugin. Report results for coverage.


## WDIO Version Compatibility

The chart below shows the versions of this reporter and their WDIO compatibility version.

| WDIO Json Reporter | WDIO |
| ------------------ | ---- |
| ^0.0.X             | v6   |



# WDIO v6 Compatibility

## Installation

* NPM
```bash
npm install wdio-coverage-reporter --save-dev
```

```js
reporters: [
  'dot',
  'coverage'
],
```

## Configuration
This plugin is fetching the test coverage information after each test into `.nyc_output`.
 - The page under test must be instrumented. Check [NYC](https://www.npmjs.com/package/nyc).
 - The report must be generated with [NYC](https://www.npmjs.com/package/nyc), after the WDIO run.


An example with instrumented code and static server can be found in `test/integration`. 
Usually, the framework of your choice has already middleware for serving and instrumenting on the fly.

Example(please add more with PR): 
- https://github.com/istanbuljs/babel-plugin-istanbul


Example:
```js
{
"scripts": {
    "test": "npm run-script instrument && npm run-script wdio && nyc report",
    "instrument": "nyc instrument ./webapp ./dist --complete-copy --delete",
    "wdio": "npx wdio wdio.conf.js",
    "cover-report": "nyc report"
  },
"nyc": {
    "all": true,
    "check-coverage": false,
    "exclude": [],
    "extension": [
      "*.js"
    ],
    "reporter": [
      "json",
      "text",
      "lcov"
    ]
  }
}
```


For more information on WebdriverIO see the [homepage](http://webdriver.io).